#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3100one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 3100"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire3100one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one31004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 

                                         
# -------------------------------------------------------------------------------------------------
# 3100
# -------------------------------------------------------------------------------------------------                                          
shot2one31004xi = {
                  1:'0x0y3099z',
                  2:'0x2052y2323z',
                  3:'0x93y3098z',
                  4:'1034x1423y2552z',
                  5:'1034x2221y1898z',
                  6:'1057x1907y2203z',
                  7:'106x2026y2343z',
                  8:'1083x2444y1568z',
                  9:'1087x2584y1322z',
                  10:'1091x1347y2569z',
                  11:'1140x2147y1922z',
                  12:'1143x1269y2586z',
                  13:'1143x1830y2225z',
                  14:'117x101y3096z',
                  15:'1189x1189y2603z',
                  16:'1202x2370y1595z',
                  17:'1215x2511y1350z',
                  18:'1225x1749y2246z',
                  19:'1230x1108y2620z',
                  20:'1241x2068y1946z',
                  21:'1266x1025y2636z',
                  22:'1297x942y2653z',
                  23:'1301x1665y2267z',
                  24:'1317x2289y1622z',
                  25:'1337x1984y1970z',
                  26:'1338x2432y1378z',
                  27:'133x128y3094z',
                  28:'1371x1577y2288z',
                  29:'140x2773y1378z',
                  30:'1426x2204y1648z',
                  31:'1427x1895y1994z',
                  32:'1436x1487y2309z',
                  33:'1456x2347y1406z',
                  34:'148x158y3092z',
                  35:'1495x1394y2330z',
                  36:'14x370y3077z',
                  37:'1511x1803y2018z',
                  38:'1530x2112y1674z',
                  39:'1548x1299y2350z',
                  40:'1569x2256y1433z',
                  41:'1590x1706y2041z',
                  42:'1595x1202y2370z',
                  43:'159x189y3090z',
                  44:'1627x2016y1700z',
                  45:'1636x1103y2390z',
                  46:'1662x1607y2064z',
                  47:'1676x2159y1461z',
                  48:'167x222y3087z',
                  49:'1719x1916y1726z',
                  50:'1728x1504y2087z',
                  51:'173x256y3084z',
                  52:'174x327y3077z',
                  53:'175x291y3081z',
                  54:'175x375y3172z',
                  55:'1777x2058y1488z',
                  56:'1788x1398y2110z',
                  57:'178x2571y1722z',
                  58:'17x25y3099z',
                  59:'1805x1811y1752z',
                  60:'1841x1291y2133z',
                  61:'1872x1951y1515z',
                  62:'1884x1702y1777z',
                  63:'1957x1590y1802z',
                  64:'1960x1840y1542z',
                  65:'2023x1474y1828z',
                  66:'2042x1725y1569z',
                  67:'204x2340y2022z',
                  68:'209x1994y2363z',
                  69:'2117x1606y1595z',
                  70:'241x2867y1152z',
                  71:'284x2748y1405z',
                  72:'30x338y3081z',
                  73:'310x1957y2383z',
                  74:'310x2541y1747z',
                  75:'324x2306y2045z',
                  76:'33x52y3099z',
                  77:'389x2839y1180z',
                  78:'3x31y3099z',
                  79:'3x62y3099z',
                  80:'407x1915y2403z',
                  81:'425x2715y1433z',
                  82:'43x2594y1696z',
                  83:'440x2266y2068z',
                  84:'440x2504y1773z',
                  85:'44x306y3084z',
                  86:'45x81y3098z',
                  87:'500x1867y2422z',
                  88:'535x2803y1209z',
                  89:'54x111y3097z',
                  90:'54x273y3087z',
                  91:'553x2219y2091z',
                  92:'564x2675y1460z',
                  93:'566x2460y1798z',
                  94:'590x1816y2442z',
                  95:'60x240y3090z',
                  96:'61x142y3096z',
                  97:'64x174y3094z',
                  98:'64x207y3092z',
                  99:'662x2167y2114z',
                  100:'675x1759y2461z',
                  101:'678x2759y1237z',
                  102:'689x2410y1823z',
                  103:'699x2627y1488z',
                  104:'756x1699y2479z',
                  105:'768x2110y2137z',
                  106:'808x2353y1848z',
                  107:'818x2708y1266z',
                  108:'82x2368y1998z',
                  109:'831x2573y1515z',
                  110:'833x1635y2498z',
                  111:'869x2047y2159z',
                  112:'905x1567y2516z',
                  113:'91x2887y1123z',
                  114:'924x2290y1873z',
                  115:'954x2650y1294z',
                  116:'959x2512y1542z',
                  117:'965x1979y2181z',
                  118:'972x1497y2534z',
                  119:'97x76y3097z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire3100one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire3100one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3100ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3100ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3100ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3100ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3100ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE31004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one31004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3100ONE4XI - SUCCEEDED TO PUT SHOT2ONE31004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE31004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3100ONE4XI *** FAILED TO PUT SHOT2ONE31004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3100ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one31004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one31004xi</nack2put4xi>" 
              
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
       
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3100ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one31004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE3100ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3100ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        #  
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3100one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
